;;|=========================================================================|
;;|                         COPYRIGHT NOTICE                                |
;;|                                                                         |
;;|             Copyright 1990, 1991, 1992, 1993, 1994 Mark Tarver          |
;;|                                                                         |
;;|        Permission to use, copy, and distribute this software and        |
;;| its documentation for any purpose is hereby granted providing           |
;;| any such use, copying and distribution is not done                      |
;;| for money, securities or any other pecuniary benefit and that both      |
;;| the above copyright and this permission notice appear in all copies     |
;;| and in the supporting documentation.  Any modification of the software  |
;;| or documentation should be accompanied by the name of the author of the |
;;| modification, and Mark Tarver must be formally notified                 |
;;| of this modification before distributing the software.                  |
;;|                                                                         |
;;|       Any commercial use of this software or use of the names "SEQUEL", |
;;| or "Mark Tarver" in connection with any version, modified or            |
;;| unmodified, of this software, through publicity or advertising,         |
;;| requires written permission.  Mark Tarver makes no                      |
;;| representation about the suitability of this software for any purpose.  |
;;| SEQUEL is provided "as is" without express or implied warranty.         |
;;|                                                                         |
;;|       Mark Tarver disclaims all warranties with regard to               |
;;| this software, including all implied warranties of merchantability and  |
;;| fitness. In no event shall Mark Tarver be liable for any                |
;;| special, indirect or consequential damages or any damages whatsoever    |
;;| resulting from loss of use, data or profits, whether in an action of    |
;;| contract, negligence or other tortious action, arising out of or in     |
;;| connection with the use or performance of this software.                |
;;|                                                                         |
;;|=========================================================================|

(in-package :sequel)

(defun proof-object
       (fp1 fp2 continuation)
       (cond ((and (rename '(var#1? var#2?))
                   (bind var#1? fp1)
                   (bind var#2? fp2)
                   (change-stacks)
                   (phi (lderef var#1?)
                        'proof
                        (lderef var#2?)
                        continuation)))
             ((backtrack))))

(defun t-exprrewrite
       (fp1)
       (cond ((and (consp fp1)
                   (= (length fp1) 3)
                   (and (consp (car fp1))
                        (= (length (car fp1)) 3))
                   (eq 'cons (caar fp1))
                   (and (consp (caddr (car fp1)))
                        (= (length (caddr (car fp1)))
                           3))
                   (eq 'cons
                       (caadr (cdar fp1)))
                   (eq '*
                       (cadar (cddar fp1)))
                   (and (consp (caddr (caddr (car fp1))))
                        (= (length (caddr (caddr (car fp1))))
                           3))
                   (eq 'cons
                       (caadr (cdadr (cdar fp1))))
                   (null (caddr (caddr (caddr (car fp1)))))
                   (eq '* (cadr fp1))
                   (eq 't-expr (caddr fp1)))
              (list (list (cadar fp1) '* 'wff)
                    (list (cadar (cddar (cddar fp1)))
                          '*
                          'type)))
             (t fp1)))

(defun sequentrewrite
       (fp1)
       (cond ((and (consp fp1)
                   (= (length fp1) 3)
                   (and (consp (car fp1))
                        (= (length (car fp1)) 3))
                   (eq 'cons (caar fp1))
                   (and (consp (caddr (car fp1)))
                        (= (length (caddr (car fp1)))
                           3))
                   (eq 'cons
                       (caadr (cdar fp1)))
                   (turnstile
                       (cadar (cddar fp1)))
                   (and (consp (caddr (caddr (car fp1))))
                        (= (length (caddr (caddr (car fp1))))
                           3))
                   (eq 'cons
                       (caadr (cdadr (cdar fp1))))
                   (null (caddr (caddr (caddr (car fp1)))))
                   (eq '* (cadr fp1))
                   (eq 'sequent (caddr fp1)))
              (list (list (cadar fp1)
                          '*
                          (list 'list 't-expr))
                    (list (cadar (cddar (cddar fp1)))
                          '*
                          't-expr)))
             (t fp1)))
